function wait_ani()
{
	ent_cycle("wait",my.SKILL17);
	my.SKILL17 += 4 * TIME;
	if(my.SKILL17 > 100) { my.SKILL17 = 0; }
}

function ko_ani()
{
	ent_frame("ko",my.SKILL17);
	my.SKILL17 += 10 * TIME;
	if(my.SKILL17 > 100)
	{
		my.SKILL17 = 0;
	}
}

function alien1_event()
{
	if(EVENT_TYPE == EVENT_ENTITY)
	{
		if(you.SKILL48 == 1 || you.SKILL48 == 50 || you.SKILL48 == 3 || you.SKILL48 == 4)
		{
			my.SKILL40 = 0;

			if(altmds == 1)
			{
				if(you.SKILL48 == 50)
				{
					my.SKILL24 = 4;

					my.SKILL21 = you.SKILL4;
					my.SKILL22 = 0;
					my.SKILL23 = 0;
					vec_rotate(my.SKILL21,you.PAN);
				}
			}
		}
	}
	if(EVENT_TYPE == EVENT_IMPACT)
	{
		if(you.SKILL48 == 1 || you.SKILL48 == 50 || you.SKILL48 == 3 || you.SKILL48 == 4)
		{
			my.SKILL40 = 0;

			if(altmds == 1)
			{
				if(you.SKILL48 == 50)
				{
					my.SKILL24 = 4;

					my.SKILL21 = you.SKILL4;
					my.SKILL22 = 0;
					my.SKILL23 = 0;
					vec_rotate(my.SKILL21,you.PAN);
				}
			}
		}
	}
}

SOUND electr = <elecs.wav>;
SOUND roar1 = <roar1.wav>;

action alie1
{
	my.ENABLE_ENTITY = ON;

	my.ENABLE_IMPACT = ON;

	my.EVENT = alien1_event;

	my.FAT = OFF;
	my.NARROW = ON;

	my.TRANSPARENT = ON;
	my.ALPHA = 0;

	my.SKILL48 = 2;					#erkennungsvariable (2 steht fuer alien typ1)
	my.SKILL40 = 1;					#energievariable (health)

	my.SKILL1 = 50;

	my.SKILL20 = 270;

#	CREATE(<sca2.pcx>,my.X,wdot);

	PLAY_ENTSOUND(MY,electr,900);

	while(my.SKILL40 > 0 && my.SKILL20 > 0)
	{
		my.SKILL20 -= 1 * TIME;

		my.MAX_X = 6;
		my.MIN_X = -8;
		my.MAX_Y = 16;
		my.MIN_Y = -16;
		my.MAX_Z = 26;
		my.MIN_Z = -38;

		my.SKIN = 2;

		skraft();

		if(my.ALPHA < 100)
		{
			my.ALPHA += 3 * TIME;
		} else {
			my.TRANSPARENT = OFF;
		}
		if(player != NULL)
		{
			if(vec_dist(my.X,player.X) > 600)
			{
				vec_set(temp,player.X);
				vec_sub(temp,my.X);
				vec_to_angle(my.PAN,temp);
				my.TILT = 0;
				my.ROLL = 0;
			}
		}

		if(my.SKILL1 > 0)
		{
			my.SKILL1 -= 1 * TIME;
			my.SKILL7 = 0;
			wait_ani();
		} else {
			my.SKILL7 = (17 + hardcore) * TIME;

			run_ani();
		}

		MOVE(MY,my.SKILL7,my.SKILL14);
		wait(1);
	}

	my.PASSABLE = ON;

	wait(1);

	if(altmds != 1)
	{
		PLAY_ENTSOUND(MY,roar1,1000);

		emit(40,my.X,ball_particle);

		my.SKILL17 = 0.01;

		while(my.SKILL17 != 0)
		{
			if(my.SKILL17 < 40)
			{
				my.SKIN = 1;
			} else {
				my.SKIN = 2;
			}
			ko_ani();
			wait(1);
		}
		my.TRANSPARENT = ON;
		while(my.ALPHA > 0)
		{
			my.SKIN = 2;
			my.ALPHA -= 4 * TIME;
			wait(1);
		}
	} else {
		if(my.SKILL24 == 4)
		{
			if(NUM_ACTIONS < 900)
			{
				ent_vertex(my.SKILL1,6);
				CREATE(<head1.mdl>,my.SKILL1,flyround);
				ent_vertex(my.SKILL1,21);
				CREATE(<part1.mdl>,my.SKILL1,flyround);
				ent_vertex(my.SKILL1,23);
				CREATE(<part1.mdl>,my.SKILL1,flyround);
				ent_vertex(my.SKILL1,41);
				CREATE(<part1.mdl>,my.SKILL1,flyround);
				ent_vertex(my.SKILL1,42);
				CREATE(<part1.mdl>,my.SKILL1,flyround);
				wait(1);
			}

			emit(30,my.X,bloody2_particle);

			if(NUM_ACTIONS < 900)
			{
				ent_vertex(my.SKILL1,16);
				CREATE(<part2.mdl>,my.SKILL1,flyround);
				ent_vertex(my.SKILL1,14);
				CREATE(<part1.mdl>,my.SKILL1,flyround);
				ent_vertex(my.SKILL1,12);
				CREATE(<part1.mdl>,my.SKILL1,flyround);
				ent_vertex(my.SKILL1,35);
				CREATE(<part1.mdl>,my.SKILL1,flyround);
				ent_vertex(my.SKILL1,39);
				CREATE(<part1.mdl>,my.SKILL1,flyround);
				wait(1);
			}
		} else {
			PLAY_ENTSOUND(MY,roar1,1000);

			emit(40,my.X,ball_particle);

			my.SKILL17 = 0.01;

			while(my.SKILL17 != 0)
			{
				if(my.SKILL17 < 40)
				{
					my.SKIN = 1;
				} else {
					my.SKIN = 2;
				}
				ko_ani();
				wait(1);
			}
			my.TRANSPARENT = ON;
			while(my.ALPHA > 0)
			{
				my.SKIN = 2;
				my.ALPHA -= 4 * TIME;
				wait(1);
			}
		}
	}
	wait(1);
	REMOVE(MY);
}