SYNONYM okoerp {TYPE ENTITY;}
SYNONYM arme {TYPE ENTITY;}
SYNONYM trig {TYPE ENTITY;}

bmap flame_map = <flamer.tga>;
bmap rauch_map = <rauc2.tga>;
bmap blue1_map = <blue1.pcx>;
bmap stern1_map = <stern1.pcx>;
bmap stern2_map = <stern2.pcx>;
bmap bolt_map = <bolt.pcx>;
bmap gruen_map = <grbluff.pcx>;
bmap lila_map = <libluff.pcx>;
bmap pink_map = <pibluff.pcx>;
bmap gold_map = <yebluff.pcx>;
bmap red1_map = <redpad1.pcx>;
bmap red2_map = <redpad2.pcx>;
bmap blood1_map = <blut1.tga>;
bmap blood2_map = <lick1.pcx>;

function rah1_particle()
{
	if(my_age == 0)
	{
		my_transparent = on;
		my_alpha = 0;
		my_pos.X += RANDOM(20) - 10;
		my_pos.Y += RANDOM(20) - 10;
		my_pos.Z += RANDOM(20) - 10;
		my_speed.Z = 0.2 + RANDOM(1);
		my_size = 2000 + RANDOM(1000);
		my_map = rauch_map;
		my_flare = on;
#		END;
	}
	if(my_age > 40)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 29)
	{
		my_alpha = 100-(MY_AGE-30)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
}

function exp1_particle()
{
	if(my_age == 0)
	{
		my_alpha = 0;
		my_pos.X += RANDOM(17) - 8.5;
		my_pos.Y += RANDOM(17) - 8.5;
		my_pos.Z += RANDOM(17) - 8.5;
		my_speed.X = RANDOM(2) - 1;
		my_speed.Y = RANDOM(2) - 1;
		my_speed.Z = 1 + RANDOM(2);
		my_size = 1200 + RANDOM(600);
		my_map = flame_map;
		my_flare = on;
		my_bright = on;
		my_color.blue = 0;
#		END;
	}
	if(my_age >= 100)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 80)
	{
		my_alpha = 80 - (my_age-80)*3;
	}
	if(my_age > 30 && my_age < 79)
	{
		my_alpha = (MY_AGE - 30) * 2;
	}
	if(my_age > 30 && my_age < 32 && my_color.blue == 0)
	{
		my_bright = off;
		my_speed.X = 0;
		my_speed.Y = 0;
		my_size = 2000 + RANDOM(3200);
		my_map = rauch_map;
		my_color.blue = 1;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
}

function exp2_particle()
{
	if(my_age == 0)
	{
		my_size = 1200 + RANDOM(3000);
		my_alpha = 0;
		my_pos.X += RANDOM(17) - 8.5;
		my_pos.Y += RANDOM(17) - 8.5;
		my_pos.Z += RANDOM(17) - 8.5;
		my_speed.X = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Y = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Z = (RANDOM(30) - 15) / (my_size / 500);
		my_map = flame_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
}

function exp3_particle()
{
	if(my_age == 0)
	{
		my_size = 500 + RANDOM(300);
		my_pos.X += RANDOM(5) - 2.5;
		my_pos.Y += RANDOM(5) - 2.5;
		my_pos.Z += RANDOM(5) - 2.5;
		my_alpha = 0;
		my_map = flame_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
}

function bloody1_particle()
{
	if(my_age == 0)
	{
		my_size = 500 + RANDOM(300);
		my_pos.X += RANDOM(5) - 2.5;
		my_pos.Y += RANDOM(5) - 2.5;
		my_pos.Z += RANDOM(5) - 2.5;
		my_alpha = 0;
		my_map = blood1_map;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
}

function bloody2_particle()
{
	if(my_age == 0)
	{
		my_size = 50 + RANDOM(200);
		my_pos.X += RANDOM(5) - 2.5;
		my_pos.Y += RANDOM(5) - 2.5;
		my_pos.Z += RANDOM(5) - 2.5;
		my_speed.X = (RANDOM(4) - 2);
		my_speed.Y = (RANDOM(4) - 2);
		my_speed.Z = (RANDOM(2) + 3);
		my_alpha = 100;
		my_map = blood2_map;
	}
	if(my_age > 90)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 50)
	{
		my_alpha = 150 - my_age;
	}
	if(my_age > 5)
	{
		my_speed.Z = 4 - my_age/10;
	}
}

function exp4_particle()
{
	if(my_age == 0)
	{
		my_size = 1200 + RANDOM(3000);
		my_alpha = 0;
		my_pos.X += RANDOM(17) - 8.5;
		my_pos.Y += RANDOM(17) - 8.5;
		my_pos.Z += RANDOM(17) - 8.5;
		my_speed.X = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Y = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Z = (RANDOM(30) - 15) / (my_size / 500);
		my_map = blue1_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
}

function exp5_particle()
{
	if(my_age == 0)
	{
		my_size = 1200 + RANDOM(3000);
		my_alpha = 0;
		my_pos.X += RANDOM(17) - 8.5;
		my_pos.Y += RANDOM(17) - 8.5;
		my_pos.Z += RANDOM(17) - 8.5;
		my_speed.X = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Y = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Z = (RANDOM(30) - 15) / (my_size / 500);
		my_map = gruen_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
}

function exp6_particle()
{
	if(my_age == 0)
	{
		my_size = 1200 + RANDOM(3000);
		my_alpha = 0;
		my_pos.X += RANDOM(17) - 8.5;
		my_pos.Y += RANDOM(17) - 8.5;
		my_pos.Z += RANDOM(17) - 8.5;
		my_speed.X = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Y = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Z = (RANDOM(30) - 15) / (my_size / 500);
		my_map = lila_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
}

function exp7_particle()
{
	if(my_age == 0)
	{
		my_size = 1200 + RANDOM(3000);
		my_alpha = 0;
		my_pos.X += RANDOM(17) - 8.5;
		my_pos.Y += RANDOM(17) - 8.5;
		my_pos.Z += RANDOM(17) - 8.5;
		my_speed.X = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Y = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Z = (RANDOM(30) - 15) / (my_size / 500);
		my_map = pink_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
}

function exp8_particle()
{
	if(my_age == 0)
	{
		my_size = 1200 + RANDOM(3000);
		my_alpha = 0;
		my_pos.X += RANDOM(17) - 8.5;
		my_pos.Y += RANDOM(17) - 8.5;
		my_pos.Z += RANDOM(17) - 8.5;
		my_speed.X = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Y = (RANDOM(30) - 15) / (my_size / 500);
		my_speed.Z = (RANDOM(30) - 15) / (my_size / 500);
		my_map = gold_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
}

function fire_particle()
{
	if(my_age == 0)
	{
		my_size = 500 + RANDOM(4000);
		my_alpha = 0;
		my_pos.X += RANDOM(17) - 8.5;
		my_pos.Y += RANDOM(17) - 8.5;
		my_pos.Z += RANDOM(17) - 8.5;
		my_speed.Z = (RANDOM(15) + 15) / (my_size / 500);
		my_map = flame_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
}

function ring_particle()
{
	if(my_age == 0)
	{
		my_color.red = RANDOM(2);
		if(my_color.red >= 1)
		{
			my_color.red = 1;
		} else {
			my_color.red = -1;
		}
		my_alpha = 100;
		my_speed.X = RANDOM(4) - 2;
		my_speed.Y = my_color.red * SQRT(4 - my_speed.X * my_speed.X);
		my_size = 200 + RANDOM(50);
		my_map = blue1_map;								#red1_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_flare = on;
		my_alpha = 100-(my_age-20)*9;
	}/*
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}*/
}

function shell_particle()
{
	if(my_age == 0)
	{

		my_color.red = RANDOM(2);

		if(my_color.red >= 1)
		{
			my_color.red = 1;
		} else {
			my_color.red = -1;
		}

		my_color.green = RANDOM(2);

		if(my_color.green >= 1)
		{
			my_color.green = 1;
		} else {
			my_color.green = -1;
		}

		my_alpha = 100;
		my_speed.X = RANDOM(4) - 2;
		my_speed.Y = RANDOM(my_color.red * SQRT(4 - my_speed.X * my_speed.X));
		my_speed.Z = my_color.green * ( SQRT(4 - my_speed.Y * my_speed.Y) + SQRT(4 - my_speed.X * my_speed.X) ) * 0.5;
		my_size = 200 + RANDOM(50);
		my_map = blue1_map;													#red1_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_flare = on;
		my_alpha = 100-(my_age-20)*9;
	}/*
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}*/
}

function ball_particle()
{
	if(my_age == 0)
	{

		my_color.red = RANDOM(2);

		if(my_color.red >= 1)
		{
			my_color.red = 1;
		} else {
			my_color.red = -1;
		}

		my_color.green = RANDOM(2);

		if(my_color.green >= 1)
		{
			my_color.green = 1;
		} else {
			my_color.green = -1;
		}

		my_alpha = 100;
		my_speed.X = RANDOM(4) - 2;
		my_speed.Y = RANDOM(my_color.red * SQRT(4 - my_speed.X * my_speed.X));
		my_speed.Z = my_color.green * ( SQRT(4 - my_speed.Y * my_speed.Y - my_speed.X * my_speed.X));
		my_size = 200 + RANDOM(50);
		my_map = blue1_map;											#red2_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_flare = on;
		my_alpha = 100-(my_age-20)*9;
	}/*
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}*/
}

function elec_particle()
{
	if(my_age == 0)
	{
		my_alpha = 0;
		my_speed.x = (random(0.8) - 0.4);
		my_speed.y = (random(0.8) - 0.4);
		my_speed.z = (random(0.8) - 0.4);
		my_size = (1200+random(500));
		my_map = bolt_map;
		my_flare = on;
		my_bright= on;
#		END;
	}
 	if (my_age > 30)
	{
			MY_ACTION = NULL;
	}
	if (my_age > 7)
	{
		my_alpha = 100-MY_AGE*3.3;
	} else {
		my_alpha = my_age * 10;
	}
}

function vec_randomize(&vec,range)
{
	vec[0] = random(0.09) - 0.045;
	vec[1] = random(0.09) - 0.045;
	vec[2] = random(0.09) - 0.045;
	vec_normalize(vec,random(range));
}

function part_alphafade()
{
	my.alpha -= time+time;
	if(my.alpha <= 0)	{ my.lifespan = 0; }
}

function effect_exp1()
{
	vec_randomize(temp,0.5);
	vec_add(my.vel_X,temp);
	my.alpha = 25 + random(25);
	my.bmap = flame_map;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.move = on;
	my.function = part_alphafade;
}

function star1_particle()
{
	if(my_age == 0)
	{
		my_alpha = 0;
		my_pos.X += RANDOM(10) - 5;
		my_pos.Y += RANDOM(10) - 5;
		my_size = 50 + RANDOM(170);
		my_map = stern1_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
	if(my_age > 10 && my_age < 15)
	{
		my_bright = off;
	}
	if(my_age > 15 && my_age < 20)
	{
		my_bright = on;
	}
	if(my_age > 20 && my_age < 25)
	{
		my_bright = off;
	}
	if(my_age > 25)
	{
		my_bright = on;
	}
}

function star2_particle()
{
	if(my_age == 0)
	{
		my_alpha = 0;
		my_pos.X += RANDOM(10) - 5;
		my_pos.Y += RANDOM(10) - 5;
		my_pos.Z += RANDOM(10) - 5;
		my_size = 50 + RANDOM(170);
		my_map = stern2_map;
		my_flare = on;
		my_bright = on;
#		END;
	}
	if(my_age > 30)
	{
		MY_ACTION = NULL;
	}
	if(my_age > 19 && my_age < 30)
	{
		my_alpha = 100-(my_age-20)*9;
	}
	if(my_age <= 10)
	{
		my_alpha = MY_AGE * 10;
	}
	if(my_age > 10 && my_age < 15)
	{
		my_bright = off;
	}
	if(my_age > 15 && my_age < 20)
	{
		my_bright = on;
	}
	if(my_age > 20 && my_age < 25)
	{
		my_bright = off;
	}
	if(my_age > 25)
	{
		my_bright = on;
	}
}

action emitter1				#starstream
{
	my.PASSABLE = ON;
	my.INVISIBLE = ON;
	my.SKILL1 = 150;
	my.SKILL4 = 1 + RANDOM(1) * TIME;

	my.LIGHTRANGE = 0;
	my.LIGHT = ON;

	my.LIGHTRED = 200 + RANDOM(55);
	my.LIGHTGREEN = 200;
	my.LIGHTBLUE = 200 + RANDOM(55);

	while(my.SKILL1 > 0)
	{
		if(my.LIGHTRANGE < 300 && my.SKILL1 > 75)
		{
			my.LIGHTRANGE += 6 * TIME;
		}

		if(my.LIGHTRANGE > 0 && my.SKILL1 < 75)
		{
			my.LIGHTRANGE -= 2 * TIME;
		}

		my.SKILL1 -= 1 * TIME;

		emit(1,my.X,star1_particle);

		if(my.SKILL1 < 90 && my.SKILL1 > 80)
		{
			my.PAN += RANDOM(1) * TIME;
			my.TILT += RANDOM(3) * TIME;
			my.ROLL += RANDOM(5) * TIME;
		}

		emit(2,my.X,star2_particle);

		if(my.SKILL1 < 80 && my.SKILL1 > 70)
		{
			my.PAN -= RANDOM(5) * TIME;
			my.TILT += RANDOM(1) * TIME;
			my.ROLL -= RANDOM(3) * TIME;
		}
		move(MY,my.SKILL2,NULLVECTOR);
		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

action emitter2			#firestone
{
	my.PASSABLE = ON;
	my.INVISIBLE = ON;
	my.SKILL1 = 300 + RANDOM(20);
	my.SKILL2 = RANDOM(6) - 3 * TIME;
	my.SKILL3 = RANDOM(6) - 3 * TIME;
	my.SKILL4 = 3 + RANDOM(2) * TIME;

	my.LIGHTRANGE = 0;
	my.LIGHT = ON;

	my.LIGHTRED = 210 + RANDOM(40);
	my.LIGHTGREEN = 140 + RANDOM(60);
	my.LIGHTBLUE = 140 + RANDOM(50);

	while(my.SKILL1 > 0)
	{
		if(my.LIGHTRANGE < 300 && my.SKILL1 > 50)
		{
			my.LIGHTRANGE += 10 * TIME;
		}

		if(my.LIGHTRANGE > 0 && my.SKILL1 < 50)
		{
			my.LIGHTRANGE -= 2 * TIME;
		}

		my.SKILL1 -= 1 * TIME;

		my.SKILL4 -= 0.05 * TIME;

		emit(1,my.X,exp3_particle);

		move(MY,my.SKILL2,NULLVECTOR);

		if(content(my.X) == content_solid)
		{
			my.SKILL1 = 0;
		}
		wait(1);
	}

	emit(2,my.X,exp1_particle);

	wait(1);
	REMOVE(MY);
}

action emitter3			#the waiting one
{
	my.PASSABLE = ON;
	my.INVISIBLE = ON;
	my.SKILL1 = 200 + RANDOM(20);

	my.LIGHTRANGE = 0;
	my.LIGHT = ON;

	my.LIGHTRED = 210 + RANDOM(20);
	my.LIGHTGREEN = 160 + RANDOM(20);
	my.LIGHTBLUE = 100 + RANDOM(20);

	while(my.SKILL1 > 0)
	{
		if(my.LIGHTRANGE < 300 && my.SKILL1 > 100)
		{
			my.LIGHTRANGE += 6 * TIME;
		}

		if(my.LIGHTRANGE > 0 && my.SKILL1 < 100)
		{
			my.LIGHTRANGE -= 2 * TIME;
		}

		my.SKILL1 -= 1 * TIME;

		my.SKILL2 += 1*TIME;

		emit(2,my.X,exp2_particle);

		if(my.SKILL2 > 9 && my.SKILL1 > 50)
		{
			CREATE(<pkt.pcx>,my.X,emitter2);
			my.SKILL2 = RANDOM(2);
		}

		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

action emitter4			#the waiting one
{
	my.PASSABLE = ON;
	my.INVISIBLE = ON;
	my.SKILL1 = 200 + RANDOM(20);

	my.LIGHTRANGE = 0;
	my.LIGHT = ON;

	my.LIGHTRED = 210 + RANDOM(20);
	my.LIGHTGREEN = 160 + RANDOM(20);
	my.LIGHTBLUE = 100 + RANDOM(20);

	while(my.SKILL1 > 0)
	{
		if(my.LIGHTRANGE < 300 && my.SKILL1 > 100)
		{
			my.LIGHTRANGE += 6 * TIME;
		}

		if(my.LIGHTRANGE > 0 && my.SKILL1 < 100)
		{
			my.LIGHTRANGE -= 1 * TIME;
		}

		my.SKILL1 -= 1 * TIME;

		emit(5,my.X,exp2_particle);

		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

action emitter5			#the waiting one
{
	my.PASSABLE = ON;
	my.INVISIBLE = ON;
	my.SKILL1 = 200 + RANDOM(20);

	my.LIGHTRANGE = 0;
	my.LIGHT = ON;

	my.LIGHTRED = 200 + RANDOM(55);
	my.LIGHTGREEN = 150 + RANDOM(40);
	my.LIGHTBLUE = 80 + RANDOM(40);

	while(my.SKILL1 > 0)
	{
		if(my.LIGHTRANGE < 300 && my.SKILL1 > 100)
		{
			my.LIGHTRANGE += 6 * TIME;
		}

		if(my.LIGHTRANGE > 0 && my.SKILL1 < 100)
		{
			my.LIGHTRANGE -= 1 * TIME;
		}

		my.SKILL1 -= 1 * TIME;

		emit(5,my.X,fire_particle);

		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

action emitter6			#the waiting one
{
	my.PASSABLE = ON;
	my.INVISIBLE = ON;
	my.SKILL1 = 200 + RANDOM(20);

	my.LIGHTRANGE = 0;
	my.LIGHT = ON;

	my.LIGHTRED = 150 + RANDOM(40);
	my.LIGHTGREEN = 150 + RANDOM(40);
	my.LIGHTBLUE = 200 + RANDOM(40);

	while(my.SKILL1 > 0)
	{
		if(my.LIGHTRANGE < 300 && my.SKILL1 > 100)
		{
			my.LIGHTRANGE += 6 * TIME;
		}

		if(my.LIGHTRANGE > 0 && my.SKILL1 < 100)
		{
			my.LIGHTRANGE -= 1 * TIME;
		}

		my.SKILL1 -= 1 * TIME;

		emit(5,my.X,exp4_particle);

		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

action emitter7			#the waiting one
{
	my.PASSABLE = ON;
	my.INVISIBLE = ON;
	my.SKILL1 = 200 + RANDOM(20);

	my.LIGHTRANGE = 0;
	my.LIGHT = ON;

	my.LIGHTRED = 150 + RANDOM(30);
	my.LIGHTGREEN = 200 + RANDOM(40);
	my.LIGHTBLUE = 160 + RANDOM(30);

	while(my.SKILL1 > 0)
	{
		if(my.LIGHTRANGE < 300 && my.SKILL1 > 100)
		{
			my.LIGHTRANGE += 6 * TIME;
		}

		if(my.LIGHTRANGE > 0 && my.SKILL1 < 100)
		{
			my.LIGHTRANGE -= 1 * TIME;
		}

		my.SKILL1 -= 1 * TIME;

		emit(5,my.X,exp5_particle);

		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

action emitter8			#the waiting one
{
	my.PASSABLE = ON;
	my.INVISIBLE = ON;
	my.SKILL1 = 200 + RANDOM(20);

	my.LIGHTRANGE = 0;
	my.LIGHT = ON;

	my.LIGHTRED = 200 + RANDOM(20);
	my.LIGHTGREEN = 150 + RANDOM(20);
	my.LIGHTBLUE = 200 + RANDOM(20);

	while(my.SKILL1 > 0)
	{
		if(my.LIGHTRANGE < 300 && my.SKILL1 > 100)
		{
			my.LIGHTRANGE += 6 * TIME;
		}

		if(my.LIGHTRANGE > 0 && my.SKILL1 < 100)
		{
			my.LIGHTRANGE -= 1 * TIME;
		}

		my.SKILL1 -= 1 * TIME;

		emit(5,my.X,exp6_particle);

		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

action emitter9			#the waiting one
{
	my.PASSABLE = ON;
	my.INVISIBLE = ON;
	my.SKILL1 = 200 + RANDOM(20);

	my.LIGHTRANGE = 0;
	my.LIGHT = ON;

	my.LIGHTRED = 230 + RANDOM(10);
	my.LIGHTGREEN = 220 + RANDOM(10);
	my.LIGHTBLUE = 230 + RANDOM(10);

	while(my.SKILL1 > 0)
	{
		if(my.LIGHTRANGE < 300 && my.SKILL1 > 100)
		{
			my.LIGHTRANGE += 6 * TIME;
		}

		if(my.LIGHTRANGE > 0 && my.SKILL1 < 100)
		{
			my.LIGHTRANGE -= 1 * TIME;
		}

		my.SKILL1 -= 1 * TIME;

		emit(5,my.X,exp7_particle);

		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

action emitter10		#the waiting one
{
	my.PASSABLE = ON;
	my.INVISIBLE = ON;
	my.SKILL1 = 200 + RANDOM(20);

	my.LIGHTRANGE = 0;
	my.LIGHT = ON;

	my.LIGHTRED = 200 + RANDOM(20);
	my.LIGHTGREEN = 200 + RANDOM(20);
	my.LIGHTBLUE = 80 + RANDOM(40);

	while(my.SKILL1 > 0)
	{
		if(my.LIGHTRANGE < 300 && my.SKILL1 > 100)
		{
			my.LIGHTRANGE += 6 * TIME;
		}

		if(my.LIGHTRANGE > 0 && my.SKILL1 < 100)
		{
			my.LIGHTRANGE -= 1 * TIME;
		}

		my.SKILL1 -= 1 * TIME;

		emit(5,my.X,exp8_particle);

		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

function pad_event()
{
	if(EVENT_TYPE == EVENT_BLOCK)
	{
		CREATE(<redpad1.pcx>,my.X,pad1);
		my.SKILL1 = 0;
	}
}

action emitterR			#redpad
{
#	my.ENABLE_BLOCK = ON;

#	my.EVENT = pad_event;

	my.FACING = ON;
	my.FAT = OFF;
	my.NARROW = OFF;

	my.SKILL1 = 200;

	my.SKILL2 = 6 - RANDOM(12) * TIME;
	my.SKILL3 = 6 - RANDOM(12) * TIME;
	my.SKILL4 = 7 + RANDOM(2) * TIME;

	while(my.SKILL1 > 0)
	{
		my.SKILL1 -= 1 * TIME;

		my.SKILL4 -= 2 * TIME;

		move(MY,NULLVECTOR,my.SKILL2);

		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

action pad1
{
	my.passable = ON;
	my.ORIENTED = ON;

	vec_to_angle(my.PAN,NORMAL);

	my.SKILL1 = 300;

	while(my.SKILL1 > 0)
	{
		my.SKILL1 -= 1*TIME;
		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

action feuering
{
	my.PASSABLE = ON;
#	my.TRANSPARENT = ON;
	my.FLARE = ON;
	my.BRIGHT = ON;
	my.ALPHA = 100;

	my.ORIENTED = ON;

	my.PAN = 0;
	my.TILT = 90;
	my.ROLL = 0;

	my.SCALE_X = 0.1;
	my.SCALE_Y = 0.1;
	my.SCALE_Z = 0.1;

	while(my.ALPHA > 0)
	{
		my.SCALE_X += 0.2 * TIME;
		my.SCALE_Y += 0.2 * TIME;
		my.SCALE_Z += 0.2 * TIME;

		my.ALPHA -= 2 * TIME;

		wait(1);
	}
	REMOVE(MY);
}

action ballexp
{
	my.PASSABLE = ON;
	my.TRANSPARENT = ON;
#	my.FLARE = ON;
	my.BRIGHT = ON;

	my.ALPHA = 0;

	my.SKILL1 = 0.2 + RANDOM(0.7);

	my.SCALE_X = my.SKILL1;
	my.SCALE_Y = my.SKILL1;
	my.SCALE_Z = my.SKILL1;

	while(my.ALPHA < 60)
	{
		my.ALPHA += (2 + RANDOM(2) ) * TIME;
		my.PAN += (2 + RANDOM(1) ) * TIME;
		my.TILT += (3 + RANDOM(1) ) * TIME;
		my.ROLL += (2.7 + RANDOM(1) ) * TIME;

		my.SCALE_X += 0.5 * TIME;
		my.SCALE_Y += 0.5 * TIME;
		my.SCALE_Z += 0.5 * TIME;

		wait(1);
	}
	while(my.ALPHA > 0)
	{
		my.ALPHA -= (1 + RANDOM(2) ) * TIME;
		my.PAN += (2 + RANDOM(1) ) * TIME;
		my.TILT += (3 + RANDOM(1) ) * TIME;
		my.ROLL += (2.7 + RANDOM(1) ) * TIME;

		my.SCALE_X -= 0.2 * TIME;
		my.SCALE_Y -= 0.2 * TIME;
		my.SCALE_Z -= 0.2 * TIME;

		wait(1);
	}
	wait(1);
	REMOVE(MY);
}

action xxl_emitter
{
	my.PASSABLE = ON;
	my.INVISIBLE = ON;

	my.SKILL1 = 150;

	while(my.SKILL1 > 0)
	{
		my.SKILL2 = my.X + RANDOM(50);
		my.SKILL3 = my.Y + RANDOM(50);
		my.SKILL4 = my.Z + RANDOM(50);

		if(my.SKILL1 < 147 && my.SKILL5 == 0)
		{
			CREATE(<explos.mdl>,my.SKILL2,ballexp);
			my.SKILL5 = 1;
		}

		if(my.SKILL1 < 133 && my.SKILL5 == 1)
		{
			CREATE(<explos.mdl>,my.SKILL2,ballexp);
			my.SKILL5 = 2;
		}

		if(my.SKILL1 < 119 && my.SKILL5 == 2)
		{
			CREATE(<explos.mdl>,my.SKILL2,ballexp);
			my.SKILL5 = 3;
		}

		if(my.SKILL1 < 92 && my.SKILL5 == 3)
		{
			CREATE(<explos.mdl>,my.SKILL2,ballexp);
			my.SKILL5 = 4;
		}

		if(my.SKILL1 < 55 && my.SKILL5 == 4)
		{
			CREATE(<explos.mdl>,my.SKILL2,ballexp);
			my.SKILL5 = 5;
		}

		if(my.SKILL1 < 10 && my.SKILL5 == 5)
		{
			CREATE(<explos.mdl>,my.SKILL2,ballexp);
			my.SKILL5 = 6;
		}

		my.SKILL1 -= 1 * TIME;
		wait(1);
	}
	wait(1);
	REMOVE(MY);
}