action plasmas
{
	my.ENABLE_ENTITY = ON;

	my.ENABLE_IMPACT = ON;

	my.EVENT = alien1_event;

	my.FAT = OFF;
	my.NARROW = ON;

	my.BRIGHT = ON;

	my.SKILL40 = 40;

	my.SKILL48 = 4;

	my.AMBIENT = 80;

	if(player != NULL)
	{
		vec_set(temp,player.X);
		vec_sub(temp,my.X);
		vec_to_angle(my.PAN,temp);
	}

	while(my.SKILL40 > 0)
	{
		my.SKILL2 = (100 + hardcore) * TIME;
		my.SKILL3 = 0;
		my.SKILL4 = 0;

		my.SKILL40 -= 1 * TIME;

		move(MY,my.SKILL2,NULLVECTOR);
		wait(1);
	}
	emit(20,my.X,ball_particle);
	wait(3);
	REMOVE(MY);
}

function plasmas2_event()
{
	if(EVENT_TYPE == EVENT_ENTITY)
	{
		if(you.SKILL48 == 50)
		{
			my.SKILL40 -= 1;
		}
		if(you.SKILL48 == 1)
		{
			my.SKILL40 = 0;
		}
	}
	if(EVENT_TYPE == EVENT_IMPACT)
	{
		if(you.SKILL48 == 50)
		{
			my.SKILL40 -= 1;
		}
		if(you.SKILL48 == 1)
		{
			my.SKILL40 = 0;
		}
	}
}

function boss_event()
{
	if(EVENT_TYPE == EVENT_ENTITY)
	{
		if(you.SKILL48 == 50)
		{
			my.SKILL40 -= 1;
			my.SKILL14 = 4;
		}
	}
	if(EVENT_TYPE == EVENT_IMPACT)
	{
		if(you.SKILL48 == 50)
		{
			my.SKILL40 -= 1;
			my.SKILL14 = 4;
		}
	}
}

action plasmas2
{
	my.ENABLE_ENTITY = ON;

	my.ENABLE_IMPACT = ON;

	my.EVENT = plasmas2_event;

	my.FAT = OFF;
	my.NARROW = ON;

	my.TRANSPARENT = ON;
	my.BRIGHT = ON;

	my.SKILL40 = 20;
	my.SKILL41 = 160;

	my.SKILL48 = 4;

	my.AMBIENT = 80;

	while(my.SKILL40 > 0 && my.SKILL41 > 0)
	{
		if(player != NULL)
		{
			vec_set(temp,player.X);
			vec_sub(temp,my.X);
			vec_to_angle(my.SKILL4,temp);
		}

		my.SKILL7 = my.SKILL4 - my.PAN;

		if(my.SKILL7 > 0)
		{
			if(my.SKILL7 <= 180)
			{
				my.PAN += 3 * TIME;
			} else {
				my.PAN -= 3 * TIME;
			}
		} else {
			if(my.SKILL7 >= -180 && my.SKILL7 < 0)
			{
				my.PAN -= 3 * TIME;
			} else {
				my.PAN += 3 * TIME;
			}
		}

		my.SKILL7 = my.SKILL5 - my.TILT;

		if(my.SKILL7 > 0)
		{
			if(my.SKILL7 <= 180)
			{
				my.TILT += 3 * TIME;
			} else {
				my.TILT -= 3 * TIME;
			}
		} else {
			if(my.SKILL7 >= -180 && my.SKILL7 < 0)
			{
				my.TILT -= 3 * TIME;
			} else {
				my.TILT += 3 * TIME;
			}
		}

		my.SKILL1 = (18 + hardcore) * TIME;
		my.SKILL2 = 0;
		my.SKILL3 = 0;

		my.SKILL41 -= 1 * TIME;

		move(MY,my.SKILL1,NULLVECTOR);
		wait(1);
	}
	my.PASSABLE = ON;
	emit(20,my.X,elec_particle);
	wait(3);
	REMOVE(MY);
}


action boss
{
	my.ENABLE_ENTITY = ON;

	my.ENABLE_IMPACT = ON;

	my.EVENT = boss_event;

	my.NARROW = OFF;
	my.FAT = ON;

	my.SKILL48 = 4;

	while(mission1 < 6) { wait(1); }

	if(player != NULL)
	{
		vec_set(temp,player.X);
		vec_sub(temp,my.X);
		vec_to_angle(my.PAN,temp);
	}

	while(my.Z < 2400)
	{
		if(player != NULL)
		{
			vec_set(temp,player.X);
			vec_sub(temp,my.X);
			vec_to_angle(my.PAN,temp);
		}

		my.Z += 3 * TIME;
		if(my.X > 16973)
		{
			my.X -= 5 * TIME;
		}
		wait(1);
	}
	while(my.X > 16973)
	{
		if(player != NULL)
		{
			vec_set(temp,player.X);
			vec_sub(temp,my.X);
			vec_to_angle(my.PAN,temp);
		}

		my.X -= 5 * TIME;
		wait(1);
	}

	my.SKILL1 = 0;
	my.SKILL2 = 1;

	my.SKILL40 = 600;

	while(my.SKILL40 > 0)
	{
		if(my.SKILL14 <= 0)
		{
			my.SKIN = 2;
		} else {
			my.SKIN = 1;
			my.SKILL14 -= 1 * TIME;
		}

		ent_cycle("frame",my.SKILL10);
		my.SKILL10 += 5 * TIME;
		if(my.SKILL10 > 100) { my.SKILL10 = 0; }
		if(my.SKILL2 == 1)
		{
			if(player != NULL)
			{
				vec_set(temp,player.X);
				vec_sub(temp,my.X);
				vec_to_angle(my.PAN,temp);
			}

			emit(5,my.X,exp2_particle);

			my.SKILL1 += 1 * TIME;
			if(my.SKILL1 > 60)
			{
				my.SKILL2 = 2;
				my.SKILL1 = 0;
			}

			ent_vertex(my.SKILL4,45);

			my.SKILL3 += 1 * TIME;
			if(my.SKILL3 > 10)
			{
				CREATE(<yelbom.mdl>,my.SKILL4,bombgelb);
				my.SKILL3 = 0;
			}
		}
		if(my.SKILL2 == 2)
		{
			my.SKILL7 = 16050;
			my.SKILL8 = 12500;
			my.SKILL9 = 2400;

			vec_set(temp,my.SKILL7);
			vec_sub(temp,my.X);
			vec_to_angle(my.PAN,temp);

			my.SKILL11 = (15 + hardcore) * TIME;
			my.SKILL12 = 0;
			my.SKILL13 = 0;

			MOVE(MY,my.SKILL11,NULLVECTOR);

			if(vec_dist(my.X,my.SKILL7) < 500)
			{
				if(player != NULL)
				{
					vec_set(temp,player.X);
					vec_sub(temp,my.X);
					vec_to_angle(my.PAN,temp);
				}

				my.SKILL7 = 0;
				my.SKILL1 = 0;
				my.SKILL2 = 3;
			}
		}
		if(my.SKILL2 == 3)
		{
			my.SKILL1 += 1 * TIME;
			my.SKILL7 += 1 * TIME;
			emit(1,my.X,fire_particle);

			ent_vertex(my.SKILL4,45);

			if(my.SKILL1 > 10 && my.SKILL7 > 2)
			{
				CREATE(<bluef.tga>,my.SKILL4,plasmas);
				my.SKILL7 = 0;
			}
			if(my.SKILL1 > 80)
			{
				my.SKILL1 = 0;
				my.SKILL2 = 4;
			}
		}
		if(my.SKILL2 == 4)
		{
			my.SKILL7 = 15000;
			my.SKILL8 = 10000;
			my.SKILL9 = 2400;

			vec_set(temp,my.SKILL7);
			vec_sub(temp,my.X);
			vec_to_angle(my.PAN,temp);

			my.SKILL11 = (15 + hardcore) * TIME;
			my.SKILL12 = 0;
			my.SKILL13 = 0;

			MOVE(MY,my.SKILL11,NULLVECTOR);

			if(vec_dist(my.X,my.SKILL7) < 500)
			{
				if(player != NULL)
				{
					vec_set(temp,player.X);
					vec_sub(temp,my.X);
					vec_to_angle(my.PAN,temp);
				}

				my.SKILL7 = 0;
				my.SKILL1 = 0;

				my.SKILL2 = 5;
			}
		}
		if(my.SKILL2 == 5)
		{
			if(player != NULL)
			{
				vec_set(temp,player.X);
				vec_sub(temp,my.X);
				vec_to_angle(my.PAN,temp);
			}

			my.SKILL1 += 1 * TIME;
			my.SKILL7 += 1 * TIME;
			emit(1,my.X,fire_particle);

			ent_vertex(my.SKILL4,45);

			if(my.SKILL1 > 10 && my.SKILL7 > 2)
			{
				CREATE(<bluef.tga>,my.SKILL4,plasmas);
				my.SKILL7 = 0;
			}
			if(my.SKILL1 > 80)
			{
				my.SKILL1 = 0;
				my.SKILL2 = 6;
			}
		}
		if(my.SKILL2 == 6)
		{
			my.SKILL7 = 16973;
			my.SKILL8 = 11600;
			my.SKILL9 = 2400;

			vec_set(temp,my.SKILL7);
			vec_sub(temp,my.X);
			vec_to_angle(my.PAN,temp);

			my.SKILL11 = (15 + hardcore) * TIME;
			my.SKILL12 = 0;
			my.SKILL13 = 0;

			MOVE(MY,my.SKILL11,NULLVECTOR);

			if(vec_dist(my.X,my.SKILL7) < 500)
			{
				if(player != NULL)
				{
					vec_set(temp,player.X);
					vec_sub(temp,my.X);
					vec_to_angle(my.PAN,temp);
				}

				my.SKILL7 = 0;
				my.SKILL1 = 0;

				my.SKILL2 = 7;
			}
		}
		if(my.SKILL2 == 7)
		{
			if(player != NULL)
			{
				vec_set(temp,player.X);
				vec_sub(temp,my.X);
				vec_to_angle(my.PAN,temp);
			}

			my.SKILL1 += 1 * TIME;
			my.SKILL7 += 1 * TIME;
			emit(1,my.X,fire_particle);

			ent_vertex(my.SKILL4,45);

			if(my.SKILL1 > 10 && my.SKILL7 > 10)
			{
				CREATE(<blue1.pcx>,my.SKILL4,plasmas2);
				my.SKILL7 = 0;
			}
			if(my.SKILL1 > 80)
			{
				my.SKILL1 = 0;
				my.SKILL2 = 1;
			}
		}
		wait(1);
	}
	my.PASSABLE = ON;
	while(my.AMBIENT > -70)
	{
		my.FRAME = 1;
		my.SKIN = 2;
		my.AMBIENT -= 3 * TIME;
		wait(1);
	}
	my.TRANSPARENT = ON;
	my.ALPHA = 100;
	while(my.ALPHA > 0)
	{
		my.FRAME = 1;
		my.SKIN = 2;
		my.ALPHA -= 2 * TIME;
		my.Z -= 1 * TIME;
		emit(5,my.X,exp2_particle);
		wait(1);
	}
	soweit = 5;
	wait(1);
	REMOVE(MY);
}
