function shuttle_event()
{
	if(EVENT_TYPE == EVENT_ENTITY)
	{
		if(you.SKILL48 == 50)
		{
			my.SKILL40 -= 1;
			my.SKILL8 = 4;

			if(altmds == 1)
			{
				my.SKILL21 = you.SKILL4;
				my.SKILL22 = 0;
				my.SKILL23 = 0;
				vec_rotate(my.SKILL21,you.PAN);
			}
		}
	}
	if(EVENT_TYPE == EVENT_IMPACT)
	{
		if(you.SKILL48 == 50)
		{
			my.SKILL40 -= 1;
			my.SKILL8 = 4;

			if(altmds == 1)
			{
				my.SKILL21 = you.SKILL4;
				my.SKILL22 = 0;
				my.SKILL23 = 0;
				vec_rotate(my.SKILL21,you.PAN);
			}
		}
	}
}

action shuttle1
{
	my.ENABLE_ENTITY = ON;

	my.ENABLE_IMPACT = ON;

	my.EVENT = shuttle_event;

	my.NARROW = OFF;
	my.FAT = ON;

#	my.TRANSPARENT = ON;
	my.ALPHA = 100;

	my.SKILL48 = 4;					#erkennungsvariable
	my.SKILL40 = 60;				#energievariable (health)

	my.LIGHTRED = 250;
	my.LIGHTGREEN = 210;
	my.LIGHTBLUE = 200;

	while(my.SKILL40 > 0)
	{

		my.MAX_X = 144;
		my.MIN_X = -146;
		my.MAX_Y = 80;
		my.MIN_Y = -88;
		my.MAX_Z = 61;
		my.MIN_Z = -45;

		my.ROLL = 0;
		my.TILT = 0;

		my.SKILL4 = 0;
		my.SKILL5 = 0;

		vec_set(my.SKILL1,my.X);
		my.SKILL3 -= 2000;
		TRACE_MODE = IGNORE_ME + IGNORE_PASSABLE + IGNORE_MODELS + IGNORE_SPRITES + USE_BOX;
		TRACE(my.X,my.SKILL1);

		if(RESULT > 200 || RESULT == NULL)
		{
			my.SKILL6 = -5 * TIME;
		}
		if(RESULT < 170)
		{
			my.SKILL6 = 5 * TIME;
		}
		if(RESULT >= 170 && RESULT <= 200)
		{
			my.SKILL6 = 0;
		}

		my.SKILL7 += 1 * TIME;

		if(my.SKILL7 >= 100)
		{
			my.SKILL7 = 0;
			TRACE_MODE = IGNORE_ME + IGNORE_PASSABLE + IGNORE_SPRITES;
			TRACE(my.X,my.SKILL1);
			vec_set(my.SKILL11,TARGET);
			if(RESULT > 130 && RESULT < 400)
			{
				my.SKILL13 += 38.5;
				CREATE(<alien1.mdl>,my.SKILL11,alie2);
			}
		}

		if(my.SKILL8 <= 0)
		{
			my.SKIN = 1;
		} else {
			my.SKIN = 2;
			my.SKILL8 -= 1*TIME;
		}

		MOVE(MY,my.SKILL4,NULLVECTOR);

		wait(1);
	}

	my.PASSABLE = ON;
	my.LIGHTRANGE = 350;
	PLAY_ENTSOUND(my,boom1,1000);
	my.SKILL10 = 1;
	VEC_SET(my.SKILL4,NULLVECTOR);
	VEC_SET(my.SKILL7,NULLVECTOR);

	while(my.SKILL10 == 1)
	{
		emit(1,my.X,rah1_particle);
		emit(1,my.X,exp1_particle);
		emit(1,my.X,exp2_particle);
		emit(1,my.X,exp3_particle);
		emit(1,my.X,exp4_particle);

		my.SKIN = 2;

		if(my.SKILL4 < (10*TIME))
		{
			my.SKILL4 += 1*TIME;
		}
		if(my.SKILL9  > (-10*TIME))
		{
			my.SKILL9 -= 1*TIME;
		}
		if(my.TILT == 0 || my.TILT > 325)
		{
			my.TILT -= 1*TIME;
		}
		if(my.ROLL < 40)
		{
			my.ROLL += 1*TIME;
		}
		my.PAN += 1*TIME;

		if(CONTENT(my.X) == CONTENT_SOLID)
		{
			my.SKILL10 = 0;
			CREATE(<pkt.pcx>,MY.X,emitter3);
			CREATE(<pkt.pcx>,MY.X,xxl_emitter);
		}

		MOVE(MY,my.SKILL4,my.SKILL7);

		wait(1);
	}
	PLAY_ENTSOUND(my,boom1,1000);
	my.TRANSPARENT = ON;
	mission1 += 1;
	while(my.ALPHA > 0)
	{
		my.SKIN = 1;
		my.ALPHA -= 1 * TIME;
		wait(1);
	}
	REMOVE(MY);
}

action bombgelb
{
	my.PASSABLE = ON;

	my.AMBIENT = 80;

	if(player != NULL)
	{
		vec_set(temp,player.X);
		vec_sub(temp,my.X);
		vec_to_angle(MY.PAN,temp);
	}

	while(my.SKILL1 < 150)
	{
		my.SKILL2 = (44 + hardcore) * TIME;
		my.SKILL3 = 0;
		my.SKILL4 = 0;

		if(player != NULL)
		{
			if(vec_dist(my.X,player.X) < 80 && player.SKILL40 == 1)
			{
				player.SKILL40 = 0;
				my.SKILL1 = 150;
			}
		}

		my.SKILL1 += 1 * TIME;

		if(content(my.X) == CONTENT_SOLID)
		{
			my.SKILL1 = 150;
		}

		move(MY,my.SKILL2,NULLVECTOR);

		wait(1);
	}
	CREATE(<explos.mdl>,my.X,ballexp);
	wait(3);
	REMOVE(MY);
}

action flugal1
{
	my.ENABLE_ENTITY = ON;

	my.ENABLE_IMPACT = ON;

	my.EVENT = shuttle_event;

	my.NARROW = OFF;
	my.FAT = ON;

#	my.TRANSPARENT = ON;
	my.ALPHA = 100;

	my.AMBIENT = 70;

	my.SKILL48 = 4;					#erkennungsvariable
	my.SKILL40 = 30;				#energievariable (health)

	my.LIGHTRED = 250;
	my.LIGHTGREEN = 210;
	my.LIGHTBLUE = 200;

	while(my.SKILL40 > 0 && mission1 < 6)
	{
		my.SKILL5 += 10 * TIME;
		if(my.SKILL5 > 100) { my.SKILL5 = 0; }
		ent_cycle("frame",my.SKILL5);

		if(mission1 == 5)
		{
			if(player != NULL)
			{
				vec_set(temp,player.X);
				vec_sub(temp,my.X);
				vec_to_angle(my.PAN,temp);
			}

			my.TILT = 0;
			my.ROLL = 0;

			vec_set(my.SKILL2,my.X);
			my.SKILL4 += 30;

			my.SKILL1 += RANDOM(2) * TIME;

			if(my.SKILL1 > 30)
			{
				CREATE(<yelbom.mdl>,my.SKILL2,bombgelb);
				my.SKILL1 = 0;
			}
		}
		wait(1);
	}
	my.PASSABLE = ON;

	wait(1);

	if(altmds != 1)
	{
		emit(40,my.X,ball_particle);

		my.TRANSPARENT = ON;
		while(my.ALPHA > 0)
		{
			my.ALPHA -= 4 * TIME;
			wait(1);
		}
	} else {
		if(NUM_ACTIONS < 900)
		{
			ent_vertex(my.SKILL1,93);
			CREATE(<piece1.mdl>,my.SKILL1,flyround);
			ent_vertex(my.SKILL1,2);
			CREATE(<piece2.mdl>,my.SKILL1,flyround);
			ent_vertex(my.SKILL1,66);
			CREATE(<piece3.mdl>,my.SKILL1,flyround);

			emit(30,my.X,bloody2_particle);

			wait(1);
		}
	}
	wait(1);
	REMOVE(MY);
}

action flugal2
{
	my.ENABLE_ENTITY = ON;

	my.ENABLE_IMPACT = ON;

	my.EVENT = alien1_event;

	my.FAT = OFF;
	my.NARROW = ON;

	my.TRANSPARENT = ON;
	my.ALPHA = 0;

	my.AMBIENT = 70;

	while(mission1 < 5) { wait(1); }

	my.SKILL48 = 2;					#erkennungsvariable (2 steht fuer alien typ1)
	my.SKILL40 = 1;					#energievariable (health)

	my.SKILL1 = 50;

	my.SKILL20 = 400;

	PLAY_ENTSOUND(MY,electr,900);

	while(my.SKILL40 > 0 && my.SKILL20 > 0)
	{
		my.SKILL20 -= 1 * TIME;

		my.MAX_X = 6;
		my.MIN_X = -8;
		my.MAX_Y = 16;
		my.MIN_Y = -16;
		my.MAX_Z = 26;
		my.MIN_Z = -38;

		if(my.ALPHA < 100)
		{
			my.ALPHA += 3 * TIME;
		} else {
			my.TRANSPARENT = OFF;
		}
		if(player != NULL)
		{
			if(vec_dist(my.X,player.X) > 600 && my.SKILL2 != 1)
			{
				vec_set(temp,player.X);
				vec_sub(temp,my.X);
				vec_to_angle(my.PAN,temp);
			} else {
				my.SKILL2 = 1;
				my.TILT = 0;
				my.ROLL = 0;
			}
			if(vec_dist(my.X,player.X) > 1000)
			{
				my.SKILL2 = 0;
			}
		}

		if(my.SKILL1 > 0)
		{
			my.SKILL1 -= 1 * TIME;
			my.SKILL7 = (20 + hardcore) * TIME;
		} else {
			my.SKILL7 = (40 + hardcore) * TIME;
		}

		MOVE(MY,my.SKILL7,NULLVECTOR);
		wait(1);
	}

	PLAY_ENTSOUND(MY,roar1,1000);

	my.PASSABLE = ON;

	wait(1);

	if(altmds != 1)
	{
		emit(40,my.X,ball_particle);

		my.TRANSPARENT = ON;
		while(my.ALPHA > 0)
		{
			my.ALPHA -= 4 * TIME;
			wait(1);
		}
	} else {
		if(NUM_ACTIONS < 900)
		{
			ent_vertex(my.SKILL1,19);
			CREATE(<piece4.mdl>,my.SKILL1,flyround);
			ent_vertex(my.SKILL1,13);
			CREATE(<piece3.mdl>,my.SKILL1,flyround);

			emit(30,my.X,bloody2_particle);

			wait(1);
		}
	}
	wait(1);
	REMOVE(MY);
}

SYNONYM carrier1 { TYPE ENTITY; }

function satlite2_event()
{
	if(EVENT_TYPE == EVENT_ENTITY)
	{
		if(you.SKILL48 == 50)
		{
			my.SKILL8 = 4;
		}
	}
	if(EVENT_TYPE == EVENT_IMPACT)
	{
		if(you.SKILL48 == 50)
		{
			my.SKILL8 = 4;
		}
	}
}

action laserst
{
	my.ENABLE_ENTITY = ON;

	my.EVENT = bum_event;

	my.FAT = OFF;
	my.NARROW = OFF;
	my.FLARE = ON;
	my.BRIGHT = ON;
	my.FACING = ON;
	my.AMBIENT = 80;

	my.SKILL7 = 50;

	my.SKILL48 = 50;			#erkennungsvariable

	if(CARRIER1 != NULL)
	{
		vec_set(temp,carrier1.X);
		vec_sub(temp,my.X);
		vec_to_angle(my.PAN,temp);
	}

	while(my.SKILL7 > 0)
	{
		my.SKILL7 -= 1 * TIME;

		my.SKILL4 = (90 + hardcore) * TIME;
		my.SKILL5 = 0;
		my.SKILL6 = 0;

		move(MY,my.SKILL4,NULLVECTOR);
		wait(1);
	}
	remove(MY);
}

action satlite2
{
	my.ENABLE_ENTITY = ON;

	my.ENABLE_IMPACT = ON;

	my.EVENT = satlite2_event;

	my.SKILL48 = 4;

	my.AMBIENT = 70;

	my.NARROW = OFF;
	my.FAT = ON;

	while(carrier1 != NULL)
	{
		if(my.SKILL8 == 4)
		{
			vec_set(my.SKILL1,my.X);
			my.SKILL3 += 100;
			CREATE(<bluef.tga>,my.SKILL1,laserst);
			my.SKILL8 = 0;
		}
		wait(1);
	}
	my.PASSABLE = ON;
	CREATE(<pkt.pcx>,MY.X,xxl_emitter);
	wait(2);
	REMOVE(MY);
}

SYNONYM buildi1 { TYPE ENTITY; }

action carrier
{
	carrier1 = MY;

	my.ENABLE_ENTITY = ON;

	my.ENABLE_IMPACT = ON;

	my.EVENT = shuttle_event;

	while(mission1 < 5) { wait(1); }

	my.AMBIENT = 70;

#	my.TRANSPARENT = ON;
	my.ALPHA = 100;

	my.SKILL48 = 4;					#erkennungsvariable
	my.SKILL40 = 30;				#energievariable (health)

	my.LIGHTRED = 250;
	my.LIGHTGREEN = 210;
	my.LIGHTBLUE = 200;

	while(my.SKILL40 > 0)
	{
		my.SKILL1 += 1 * TIME;
		if(my.SKILL1 > 200)
		{
			vec_set(my.SKILL2,my.X);
			my.SKILL4 -= 300;
			CREATE(<flyal2.mdl>,my.SKILL2,flugal2);
			my.SKILL3 -= 200;
			CREATE(<flyal2.mdl>,my.SKILL2,flugal2);
			my.SKILL3 += 400;
			CREATE(<flyal2.mdl>,my.SKILL2,flugal2);
			my.SKILL3 -= 200;
			my.SKILL2 -= 200;
			CREATE(<flyal2.mdl>,my.SKILL2,flugal2);
			my.SKILL2 += 400;
			CREATE(<flyal2.mdl>,my.SKILL2,flugal2);
			my.SKILL1 = 0;
		}
		wait(1);
	}
	my.PASSABLE = ON;
	my.SKILL1 = 100;

	my.SKILL3 = 0;
	my.SKILL4 = 0;

	CREATE(<pkt.pcx>,my.X,emitter5);

	while(my.SKILL1 > 0)
	{
		my.SKILL2 = (60 + hardcore) * TIME;

		if(my.AMBIENT > -50)
		{
			my.AMBIENT -= 5 * TIME;
		}
		my.SKILL1 -= 1 * TIME;
		vec_set(temp,buildi1.X);
		vec_sub(temp,my.X);
		vec_to_angle(my.PAN,temp);
		MOVE(MY,my.SKILL2,NULLVECTOR);
		wait(1);
	}
	CREATE(<pkt.pcx>,MY.X,xxl_emitter);
	my.TRANSPARENT = ON;
	my.ALPHA = 100;
	while(my.ALPHA > 0)
	{
		my.ALPHA -= 4 * TIME;
		wait(1);
	}
	wait(2);
	REMOVE(MY);
}

action build1
{
	buildi1 = MY;
	wait(100);

	while(carrier1 != NULL) { wait(1); }

	my.PASSABLE = ON;

	while(my.AMBIENT > -90)
	{
		my.SKILL1 = 10750;
		my.SKILL2 = 10797 + RANDOM(2438);
		my.SKILL3 = 64 + RANDOM(1170);
		CREATE(<pkt.pcx>,my.SKILL1,emitter4);

		my.AMBIENT -= 4 * TIME;
		wait(1);
	}
	my.SKILL1 = 10750;
	my.SKILL2 = 10797 + RANDOM(2438);
	my.SKILL3 = 64 + RANDOM(1170);
	CREATE(<pkt.pcx>,my.SKILL1,xxl_emitter);

	my.SKILL1 = 10750;
	my.SKILL2 = 10797 + RANDOM(2438);
	my.SKILL3 = 64 + RANDOM(1170);
	CREATE(<pkt.pcx>,my.SKILL1,emitter5);

	my.SKILL1 = 10750;
	my.SKILL2 = 10797 + RANDOM(2438);
	my.SKILL3 = 64 + RANDOM(1170);
	CREATE(<pkt.pcx>,my.SKILL1,emitter6);

	my.SKILL1 = 10750;
	my.SKILL2 = 10797 + RANDOM(2438);
	my.SKILL3 = 64 + RANDOM(1170);
	CREATE(<pkt.pcx>,my.SKILL1,emitter7);

	my.SKILL1 = 10750;
	my.SKILL2 = 10797 + RANDOM(2438);
	my.SKILL3 = 64 + RANDOM(1170);
	CREATE(<pkt.pcx>,my.SKILL1,emitter8);

	my.SKILL1 = 10750;
	my.SKILL2 = 10797 + RANDOM(2438);
	my.SKILL3 = 64 + RANDOM(1170);
	CREATE(<pkt.pcx>,my.SKILL1,emitter9);

	my.SKILL1 = 10750;
	my.SKILL2 = 10797 + RANDOM(2438);
	my.SKILL3 = 64 + RANDOM(1170);
	CREATE(<pkt.pcx>,my.SKILL1,emitter10);

	my.SKILL1 = 10750;
	my.SKILL2 = 10797 + RANDOM(2438);
	my.SKILL3 = 64 + RANDOM(1170);
	CREATE(<pkt.pcx>,my.SKILL1,emitter3);

	my.TRANSPARENT = ON;
	my.ALPHA = 100;
	while(my.ALPHA > 0)
	{
		my.ALPHA -= 5 * TIME;
		wait(1);
	}
	REMOVE(MY);
}