action resetter
{
	trig = MY;
	my.PASSABLE = ON;
	my.INVISIBLE = ON;
	while(1)
	{
		if(my.SKILL8 != 5)
		{
			my.SKILL1 += 1*TIME;

			if(my.SKILL1 > 13)
			{
				my.SKILL1 = RANDOM(3);

				if(my.SKILL1 >= 1.5)
				{
					my.SKILL1 = 1;
				} else {
					my.SKILL1 = -1;
				}
				my.SKILL2 = RANDOM(1998)-999;
				my.SKILL3 = SQRT(998001 - my.SKILL2 * my.SKILL2) * my.SKILL1;
				my.SKILL4 = 0;

				vec_add(my.SKILL2,my.X);

				if(content(my.SKILL2) == content_empty)
				{
					vec_set(my.SKILL5,my.SKILL2);
					my.SKILL7 -= 1000;
					trace_mode = ignore_passable;
					if(trace(my.SKILL2,my.SKILL5) > 10 && trace(my.SKILL2,my.SKILL5) < 300)
					{
						CREATE(<ALIEN1.mdl>,my.SKILL2,alie1);
					}
				}
			}
		}
		wait(1);
	}
}

SOUND boom1 = <boom1.wav>;

function player_event()
{
	if(EVENT_TYPE == EVENT_TRIGGER)
	{
		my.SKILL40 = 0;
		PLAY_SOUND(boom1,80);
	}
	if(EVENT_TYPE == EVENT_ENTITY)
	{
		if((you.SKILL48 == 2 || you.SKILL48 == 3 || you.SKILL48 == 4) && my.SKILL40 == 1)
		{
			my.SKILL40 = 0;
			PLAY_SOUND(boom1,80);
		}
	}
	if(EVENT_TYPE == EVENT_IMPACT)
	{
		if((you.SKILL48 == 2 || you.SKILL48 == 3 || you.SKILL48 == 4) && my.SKILL40 == 1)
		{
			my.SKILL40 = 0;
			PLAY_SOUND(boom1,80);
		}
	}
}

action xenptara
{
	player = MY;

	my.TRIGGER_RANGE = 50;

	my.ENABLE_TRIGGER = ON;

	my.ENABLE_ENTITY = ON;

	my.ENABLE_IMPACT = ON;

	my.EVENT = player_event;

	my.FAT = OFF;
	my.NARROW = ON;

	my.AMBIENT = 50;

	my.SKILL39 = 0;
	my.SKILL38 = 3;

	my.SKILL40 = 1;			#health
	my.SKILL48 = 1;			#erkennungsnummer

	init_camera1();

	3rd_person.visible = ON;

	timerun = 6000;

	while(my.SKILL38 > 0)
	{
		if(timerun > 0)
		{
			timerun -= 1 * TIME;
		} else {
			my.SKILL38 = 0;
		}

		if(mission1 < 6 && player.X > 12247 && player.Z < 200)
		{
			CREATE(<pkt.pcx>,MY.X,emitter3);

			my.X = 10400;
			my.Y = 12000;
			my.Z = 80;

			if(my.SKILL38 > 0)
			{
				my.SKILL38 -= 1;
			}
		}

		if(mission1 == 6 && my.Z < 1500)
		{
			CREATE(<pkt.pcx>,MY.X,emitter3);

			my.X = 14600;
			my.Y = 11580;
			my.Z = 1900;

			if(my.SKILL38 > 0)
			{
				my.SKILL38 -= 1;
			}
		}

		if(my.X > 15000 && my.Z > 1590)
		{
			mission1 = 6;
		}

		if(player.SKILL40 > 0)
		{

			my.MAX_X = 6;
			my.MIN_X = -4;
			my.MAX_Y = 6;
			my.MIN_Y = -6;
			my.MAX_Z = 28;
			my.MIN_Z = -34;


			if(my.SKILL40 < 5)
			{
				my.SKILL40 = 1;
			} else {
				my.SKILL40 -= 1*TIME;
			}

			skraft();

			if(player.SKILL13 <= 2)
			{
				if(trig != NULL)
				{
					vec_set(trig.X,player.X);
				}
			}

			if(KEY_SPACE == 1 && my.SKILL13 <= 2)
			{
				xen_jump();
			}

			if(KEY_E == 1)
			{
				upzone();
			}

			if(KEY_Q == 1)
			{
				dnzone();
			}

			my.SKILL1 = -10 * MOUSE_FORCE.X;
			my.SKILL2 = TIME * my.SKILL1 + max(1-TIME*0.7,0) * my.SKILL2;
			my.PAN += TIME * MY.SKILL2;						#drehwinkel (PAN)

			my.SKILL3 = 14 * (key_w - key_s);
			my.SKILL4 = TIME * my.SKILL3 + max(1-TIME*0.7,0) * my.SKILL4;
			my.SKILL7 = TIME * MY.SKILL4;						#dist x (vorwaertslaufen)

			my.SKILL5 = 7 * (key_a - key_d);
			my.SKILL6 = TIME * my.SKILL5 + max(1-TIME*0.7,0) * my.SKILL6;
			my.SKILL8 = TIME * MY.SKILL6;						#dist y (seitwaertslaufen)

			my.SKILL14 = 0;
			my.SKILL15 = 0;

			MOVE(MY,my.SKILL7,my.SKILL14);

			if(my.SKILL39 == 0)
			{
				CREATE(<rbbt.mdl>,my.X,oberk);
				CREATE(<pkt.pcx>,my.X,resetter);
				my.SKILL39 = 1;
			}

			if(my.SKILL7 != 0 || my.SKILL8 != 0)
			{
				run_ani();
			} else {
				my.FRAME = 1;
			}

			update_view1();
		}

		if(okoerp != NULL)
		{
			okoerp.X = my.X;
			okoerp.Y = my.Y;
			okoerp.Z = my.Z;
			okoerp.PAN = my.PAN;
			okoerp.TILT = my.TILT;

			vec_for_vertex(okoerp.SKILL1,okoerp,20);
		}

		if(arme != NULL)
		{
			arme.X = okoerp.SKILL1;
			arme.Y = okoerp.SKILL2;
			arme.Z = okoerp.SKILL3;
			arme.PAN = okoerp.PAN;
			arme.TILT = okoerp.TILT + arme.SKILL1;
		}

		if(my.SKILL40 == 0)
		{
			CREATE(<pkt.pcx>,MY.X,emitter3);
			my.SKILL40 = -100;
			my.X = 0;
			my.Y = 0;
			my.Z = 300;
			my.PASSABLE = ON;

			if(my.SKILL38 > 0)
			{
				my.SKILL38 -= 1;
			}
		}

		if(my.SKILL40 < -20)
		{
			my.SKILL40 += 1*TIME;
			my.X = 0;
			my.Y = 0;
			my.Z = 300;
			my.PASSABLE = ON;
		} else {
			if(my.SKILL40 < 0)
			{
				vec_set(my.X,trig.X);
				my.PASSABLE = OFF;
				my.SKILL40 = 50;
			}
		}
		wait(1);
	}
	my.PASSABLE = ON;
	wait(1);
	soweit = 4;
	wait(1);
	remove(MY);
}

action oberk
{
	okoerp = MY;
	my.passable = ON;
	my.SKILL39 = 0;

	my.AMBIENT = 50;

	while(player != NULL)
	{
/*
		my.X = player.X;		GRRRRRRRRRRR
		my.Y = player.Y;
		my.Z = player.Z;
		my.PAN = player.PAN;
		my.TILT = player.TILT;
*/
		my.ROLL = 0;

		if(my.SKILL39 == 0)
		{
			CREATE(<rbas.mdl>,my.X,waffe);
			my.SKILL39 = 1;
		}

		wait(1); 
	}
	wait(1);
	remove(MY);
}

action geshos1
{
	my.ENABLE_BLOCK = ON;
	my.ENABLE_ENTITY = ON;

	my.EVENT = bum_event;

	my.FAT = OFF;
	my.NARROW = OFF;
	my.FLARE = ON;
	my.BRIGHT = ON;
	my.FACING = ON;
	my.AMBIENT = 80;

	vec_for_vertex(my.SKILL1,arme,53);
	my.X = my.SKILL1;
	my.Y = my.SKILL2;
	my.Z = my.SKILL3;
	my.PAN = arme.PAN;
	my.TILT = arme.TILT;

	my.SKILL5 = 0;
	my.SKILL6 = 0;

	my.SKILL7 = 30;

	my.SKILL48 = 50;			#erkennungsvariable

	while(my.SKILL7 > 0)
	{
		my.SKILL4 = 90 * TIME;
		my.SKILL7 -= 1 * TIME;
		move(MY,my.SKILL4,NULLVECTOR);
		wait(1);
	}

	#CREATE(<pkt.pcx>,MY.X,emitter10);

	#wait(1);
	remove(MY);
}

SOUND shot1 = <shot1.wav>;

action waffe
{
	arme = MY;
	my.passable = ON;
	my.SKILL1 = 0;
	my.SKILL18 = 0;

	my.AMBIENT = 50;

	while(player != NULL)
	{
/*
		my.X = okoerp.SKILL1;		GRRRRRRRRRRR
		my.Y = okoerp.SKILL2;
		my.Z = okoerp.SKILL3;
		my.PAN = okoerp.PAN;
		my.TILT = okoerp.TILT;
*/
		ent_vertex(my.SKILL2,53);

		if(MOUSE_LEFT == 1 && my.SKILL18 == 0 && player.SKILL40 == 1)
		{
			if(my.SKILL5 == 0)
			{
				if(my.SKILL6 == 0)
				{
					CREATE(<funke.tga>,my.SKILL2,geshos1);
					PLAY_SOUND(shot1,30);
					my.SKILL19 = RESULT;
					my.SKILL18 = 1;
					my.SKILL20 = 80;
				}
				if(my.SKILL6 == 1)
				{
					CREATE(<funke2.tga>,my.SKILL2,geshos2);
					PLAY_SOUND(shot1,30);
					my.SKILL19 = RESULT;
					my.SKILL18 = 1;
					my.SKILL20 = 60;
				}
			} else {
				if(my.SKILL7 == 0)
				{
					CREATE(<funke.tga>,my.SKILL2,geshos1);
					PLAY_SOUND(shot1,30);
					my.SKILL19 = RESULT;
					my.SKILL18 = 1;
					my.SKILL20 = 80;
				}
				if(my.SKILL7 == 1)
				{
					CREATE(<funke2.tga>,my.SKILL2,geshos2);
					PLAY_SOUND(shot1,30);
					my.SKILL19 = RESULT;
					my.SKILL18 = 1;
					my.SKILL20 = 60;
				}
			}
		}

		if(my.SKILL18 != 0)
		{
			shot_ani();
		} else {
			my.FRAME = 2;
		}

		if((sin(tilt_3rd)) > (sin(-my.SKILL1 * 0.5 + 12)))
		{
			tilt_3rd -= 2 * TIME;
		}

		if((sin(tilt_3rd)) < (sin(-my.SKILL1 * 0.5 + 12)))
		{
			tilt_3rd += 2 * TIME;
		}

		if(z3rd < (my.SKILL1 + 4))
		{
			z3rd += 2 * TIME;
		}

		if(z3rd > (my.SKILL1 -4))
		{
			z3rd -= 2 * TIME;
		}

		if(MOUSE_RIGHT == 1)
		{
			rechange();
		}

		my.ROLL = 0;
		wait(1);
	}
	wait(1);
	remove(MY);
}

function skraft()
{
	vec_set(my.SKILL10,my.X);
	my.SKILL12 -= 5000;
	trace_mode = IGNORE_ME + IGNORE_PASSABLE + use_box;
	my.skill13 = trace(MY.X,my.SKILL10);
	if(you != NULL)
	{
		if(you.SKILL48 == 31)
		{
			trace_mode = IGNORE_ME + IGNORE_PASSABLE + use_box;
			my.skill13 = trace(MY.X,my.SKILL10);
		} else {
			trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_SPRITES + IGNORE_MODELS + use_box;
			my.skill13 = trace(MY.X,my.SKILL10);
		}
	}

	if (my.skill13 > 2)
	{
		if(my.SKILL18 <= 0)
		{
			my.SKILL16 -= 2 * TIME;			#skill14,15,16 sind dist2
		}
	} else {
		if(my.SKILL18 > 0)
		{
			my.SKILL18 -= 0.1 * TIME;
		}

		if(my.SKILL9 > 0 && my.SKILL18 <= 0)
		{
			my.SKILL9 = 0;
		}

		if(my.skill13 >= 0)
		{
			my.SKILL16 = 0;
		} else {
			my.SKILL16 = 0;
			my.Z -= my.SKILL13;
		}
	}
}

function xen_jump()
{
	exclusive_global;

	my.SKILL18 = 1;
	my.SKILL9 = 25 * TIME;

	while (my.SKILL18 > 0)
	{
		my.SKILL9 = 25 * TIME;
		my.SKILL18 -= 0.1 * TIME;
		wait (1);
	}
	while(my.SKILL13 > 2)
	{
		my.SKILL9 = 30 * TIME;
		wait (1);
	}
}

function upzone()
{
	exclusive_global;
	while(KEY_E == 1) { wait(1); }
	arme.SKILL1 += 15;
	if(arme.SKILL1 > 90)
	{
		arme.SKILL1 = 90;
	}
}

function dnzone()
{
	exclusive_global;
	while(KEY_Q == 1) { wait(1); }
	arme.SKILL1 -= 15;
	if(arme.SKILL1 < -90)
	{
		arme.SKILL1 = -90;
	}
}

function run_ani()
{
	ent_cycle("run",my.SKILL17);
	my.SKILL17 += ( SQRT(my.SKILL7 * my.SKILL7) + SQRT(my.SKILL8 * my.SKILL8)) * TIME;
	if(my.SKILL17 > 100) { my.SKILL17 = 0; }
}

function shot_ani()
{
	ent_cycle("shot",my.SKILL17);
	my.SKILL17 += my.SKILL20 * TIME;
	if(my.SKILL17 > 100)
	{
		STOP_SOUND(my.SKILL19);
		my.SKILL17 = 0;
		my.SKILL18 = 0;
	}
}

function rechange()
{
	exclusive_global;
	while(MOUSE_RIGHT == 1) { wait(1); }
	if(my.SKILL5 == 0)
	{
		my.SKILL5 = 1;
	} else {
		my.SKILL5 = 0;
	}
}
